#include <cstdlib>
#include <iostream>
#include <string>
#include <conio.h>
#include <stdlib.h>


#include "serial.hpp"
#include "brick.hpp"
#include "sound.hpp"
#include "motor.hpp"
#include "sonar.hpp"
#include "sensor.hpp"

Serial bluetooth;
Sonar sonar = Sonar(0,&bluetooth);   //ultrazvuni senzor je na portu 1
Sensor touch = Sensor(1,&bluetooth); //tipkalo je na portu 2
Brick nxt = (&bluetooth);
Sound speaker = (&bluetooth);

Motor motorA = Motor(0,&bluetooth);
Motor motorB = Motor(1,&bluetooth);
Motor motorC = Motor(2,&bluetooth);//Motor C na portu 3
Sound zvuk;

using namespace std;
int main(int argc, char *argv[]){
    FILE *fp, *fp1, *fp2;

    int brz;
    int naredba; //upravljanje robotom
    int j,k,l; //zastavice za datoteke
    int i,x,y; //zastavica za naredbe
    int distance,tipkalo;
    char string [4];
    

    if(bluetooth.connect("COM6")){//Spaja se na NXT kroz com port 9
       cout << "Veza OK!" << endl;
       nxt.set_name("LEGO"); //Set the brickname to LEGO
       cout << "Firmware verzija: " << nxt.firmware_version() << endl; 
       
       touch.type_and_mode(TOUCH,BOOL_MODE); //inicijaliziranje tipkala
       sonar.setup(); //inicijaliziranje ultrazvucnog senzora
       //inicijalizacija zastavica i vrijabli
       brz=80;
       naredba=13;
       i=12;
       j=0;
       k=0;
       l=0;
       x=1;
       y=1;
       distance=0;
       tipkalo=0;
       
       
      // cout << "Postavite zeljenu brzinu!" << endl;
      // cin >> brz;
       
       while (naredba != 1){ 
            Sleep(10);
            //ucitavanje naredbe kroz datoteku "upravljanje.txt"
            if ((fp = fopen("upravljanje.txt", "r+")) !=NULL){  //kreiranje datoteke
                j=1;
            }
            
            if(j){
               
               naredba=fgetc(fp);
                          
               fclose(fp);  //zatvori datoteku  
               fopen("upravljanje.txt", "w");
               fclose(fp);
               j=0;
            } 
            
            //upisivanje udaljenosti u datoteku "udaljenost.txt"
            if ((fp1 = fopen("udaljenost.txt", "w"))!=NULL){//kreiranje datoteke
                k=1;
                
            }            
            
            if(k){
                itoa(distance,string,10);
                fputs(string,fp1); //upisi podatak o udaljenosti u datoteku
                fclose(fp1);  //zatvori datoteku
                k=0;
            }            
            
            //upisivanje vrijednosti tipkala u datoteku "tipkalo.txt"
            if ((fp1 = fopen("tipkalo.txt", "w")) !=NULL){  //kreiranje datoteke
                l=1;
            }  
                    
            if(l){
                tipkalo=touch.read();
                            
                fputc(tipkalo,fp1); //upisi vrijednost tipkala
                fclose(fp1);  //zatvori datoteku
                l=0;
            }
            
            // upravljaki i senzorski odlomci:
            
            distance=sonar.distance(); //ocitavanje udaljenosti
            
//            if (distance < 35){
//                motorB.stop();
//                motorC.stop();
//            }
            naredba=naredba-48;   
            if (naredba == 8){ //oba motora naprijed
                    motorC.on(brz); 
                    motorB.on(brz);
            }
           
            if (naredba == 5){ //oba motora zaustavljena
                    motorC.stop(); 
                    motorB.stop();
            }
                
            if (naredba == 2){ //oba motora nazad
                      motorC.on(-brz); 
                      motorB.on(-brz);
                      
                      
            } 
                  
            if (naredba == 4){ //kretanje u lijevo
                      motorC.on(-brz/4);
                      motorB.on(brz/4);
                      
            }
                      
            if (naredba == 6){ //kretanje u desno
                      motorC.on(brz/4);
                      motorB.on(-brz/4);
                      
            }
                       
            if (naredba == 0){ //zvuni signal
                      speaker.beep(200);
                      
   
            }
           
            if (naredba == 7){ //otvaranje klijeta
                      if(x){
                       motorA.reset_rotation();
                       motorA.on(10,45);
                       x=0;
                       y=1;
                       }
            }
           
            if (naredba == 9){ //zatvaranje klijeta
                      if(y){
                       motorA.reset_rotation();
                       motorA.on(-10,45);
                       
                       y=0;
                       x=1;
                       }
            }
            if (naredba == 17){ //kretanje u desno
                      motorC.on(brz/2,30);
                      motorB.on(-brz/2,30);
                      
            }
            if (naredba == 18 ){ //kretanje u desno
                      motorC.on(-brz/2,30);
                      motorB.on(brz/2,30);
                      
            }
            if (naredba == 19 ){ //kretanje u desno
                      motorC.on(brz/2,135);
                      motorB.on(brz/2,135);
                      
            }
                              
       }                      
       
       bluetooth.disconnect();//Odspaja se bluetooth
    }
    else{
        cout << "Bluetooth veza nije uspostavljena!" << endl;
   }
   
    Sleep(200);
    exit(1);
}

